import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MpMenu, MpMenuParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询小程序端菜单
 */
export async function pageMpMenu(params: MpMenuParam) {
  const res = await request.get<ApiResult<PageResult<MpMenu>>>(
    MODULES_API_URL + '/cms/mp-menu/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询小程序端菜单列表
 */
export async function listMpMenu(params?: MpMenuParam) {
  const res = await request.get<ApiResult<MpMenu[]>>(
    MODULES_API_URL + '/cms/mp-menu',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加小程序端菜单
 */
export async function addMpMenu(data: MpMenu) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-menu',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改小程序端菜单
 */
export async function updateMpMenu(data: MpMenu) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-menu',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除小程序端菜单
 */
export async function removeMpMenu(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-menu/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除小程序端菜单
 */
export async function removeBatchMpMenu(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-menu/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询小程序端菜单
 */
export async function getMpMenu(id: number) {
  const res = await request.get<ApiResult<MpMenu>>(
    MODULES_API_URL + '/cms/mp-menu/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
